%global majorversion 14

Summary: ECPG - Embedded SQL in C
Name: libecpg
Version: %majorversion.4
Release: 7%{?dist}

License: PostgreSQL
Url: http://www.postgresql.org/

Source0: https://ftp.postgresql.org/pub/source/v%version/postgresql-%version.tar.bz2


Patch3000: libecpg-10.5-rpm-pgsql.patch
Patch3001: libecpg-10.5-var-run-socket.patch
Patch3002: libecpg-12.2-external-libpq.patch
Patch3003: libecpg-10.5-no-compat-lib.patch
Patch3004: libecpg-12.2-dependency-build.patch

BuildRequires: make gcc zlib-devel
BuildRequires: glibc-devel bison flex gawk gettext
BuildRequires: krb5-devel openssl-devel openldap-devel libpq-devel

Requires: libpgtypes = %{version}-%{release}

%description
An embedded SQL program consists of code written in an ordinary programming
language, in this case C, mixed with SQL commands in specially marked sections.
To build the program, the source code (*.pgc) is first passed through the
embedded SQL preprocessor, which converts it to an ordinary C program (*.c), and
afterwards it can be processed by a C compiler.


%package devel
Summary: Development files for ECPG - Embedded SQL in C
Requires: %name = %version-%release
Requires: libpgtypes = %version-%release

%description devel
ECPG development files.  You will need to install this package to build any
package or any clients that use the ECPG to connect to a PostgreSQL server.


%package -n libpgtypes
Summary: Map PostgreSQL database types to C equivalents


%description -n libpgtypes
The pgtypes library maps PostgreSQL database types to C equivalents that can be
used in C programs. It also offers functions to do basic calculations with those
types within C, i.e., without the help of the PostgreSQL server.


%prep
%autosetup -n postgresql-%version -p1


%build
%configure \
    --disable-rpath \
    --with-ldap \
    --with-openssl \
    --with-gssapi \
    --enable-nls \
    --without-readline \
    --datadir=%_datadir/pgsql

# build may fail if with multi-thread.
make -j1 -C "src/interfaces/ecpg"


%install
%make_install -C "src/interfaces/ecpg"

find %{buildroot} -name '*.a' -delete

%find_lang ecpglib6-%majorversion
%find_lang ecpg-%majorversion


%files -f ecpglib6-%majorversion.lang
%license COPYRIGHT
%_libdir/libecpg.so.6*


%files -n libpgtypes
%license COPYRIGHT
%_libdir/libpgtypes.so.3*


%files devel -f ecpg-%majorversion.lang
%_bindir/ecpg
%_libdir/libecpg.so
%_libdir/libpgtypes.so
%_libdir/pkgconfig/libecpg.pc
%_libdir/pkgconfig/libpgtypes.pc
%_includedir/ecpg*.h
%_includedir/pgsql/informix
%_includedir/pgtypes*.h
%_includedir/sql3types.h
%_includedir/sqlca.h
%_includedir/sqlda*.h


%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.4-7
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.4-6
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 3 2023 Shuo Wang <abushwang@tencent.com> - 14.4-5
- Rebuilt for libpq 15.3

* Thu May 04 2023 cunshunxia <cunshunxia@tencent.com> - 14.4-4
- build without multi-thread to avoid build error.

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.4-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 14.4-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 09 2023 cunshunxia <cunshunxia@tencent.com> - 14.4-1
- initial build
